// Vn炤 (PC88) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x100*16*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(&buff[_offset], 1, _size, fp);
	fclose(fp);
	return true;
}

int calc_sum(unsigned char *_ptr)
{
	unsigned char *_p = _ptr;
	int sum=0;
	for (int i=0; i<0x100; i++)
	{
		sum+=*(_p++);
	}
	sum&=0xffff;
	return sum;
}

struct fpos
{
	int trk;
	int sec;
	int ofs;
	int size;
};

int main(int argc, char *argv[])
{
	char fname[11];
	int i,d;
	int id1 = 0xa033;
	int id2 = 0x3916;
	int id3 = 0xbe2e;
	int dn=-1;

	struct fpos ma[] =
	{
		{ 0x14, 0x05, 0x0000, 0x0500 },	// 100
		{ 0x14, 0x0a, 0x0000, 0x0500 },	// 101
		{ 0x14, 0x0f, 0x0000, 0x0500 },	// 102
		{ 0x16, 0x04, 0x0000, 0x0500 },	// 103
		{ 0x16, 0x09, 0x0000, 0x0500 },	// 104
		{ 0x16, 0x0e, 0x0000, 0x0500 },	// 105
		{ 0x18, 0x03, 0x0000, 0x0500 },	// 106
		{ 0x18, 0x08, 0x0000, 0x0500 },	// 107
		{ 0x18, 0x0d, 0x0000, 0x0500 },	// 108
		{ 0x00, 0x00, 0x0000, 0x0000 },	// End of Data
	};
	struct fpos mb[] =
	{
		{ 0x27, 0x0d, 0x0000, 0x0500 },	//
		{ 0x29, 0x02, 0x0000, 0x0500 },	//
		{ 0x29, 0x07, 0x0000, 0x0500 },	//
		{ 0x29, 0x0c, 0x0000, 0x0500 },	//
		{ 0x2b, 0x01, 0x0000, 0x0500 },	//
		{ 0x2b, 0x06, 0x0000, 0x0500 },	//
		{ 0x2b, 0x0b, 0x0000, 0x0500 },	//
		{ 0x00, 0x00, 0x0000, 0x0000 },	// End of Data
	};

	struct fpos mc[] =
	{
		{ 0x14, 0x05, 0x0000, 0x0500 },	//
		{ 0x14, 0x0a, 0x0000, 0x0500 },	//
		{ 0x14, 0x0f, 0x0000, 0x0500 },	//
		{ 0x16, 0x04, 0x0000, 0x0500 },	//
		{ 0x16, 0x09, 0x0000, 0x0500 },	//
		{ 0x16, 0x0e, 0x0000, 0x0500 },	//
		{ 0x18, 0x03, 0x0000, 0x0500 },	//
		{ 0x18, 0x08, 0x0000, 0x0500 },	//
		{ 0x18, 0x0d, 0x0000, 0x0500 },	//
		{ 0x46, 0x01, 0x0000, 0x0500 },	//
		{ 0x00, 0x00, 0x0000, 0x0000 },	// End of Data
	};

	if (argc<2 || argc>3)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file] (DiskNo.)\n",argv[0]);
		return 1;
	}

	if (argc==3)
	{
		// fBXNԍw
		dn = (*argv[2]|0x20)-'a';
		if (dn<0 || dn>2)
		{
		fprintf(stderr, "Usage: %s [d88file] (DiskNo.)\n",argv[0]);
		return 1;
		}
	}

	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (d=0; d<numdisk; d++)
	{
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x10);
		disk.ReadDATA1(0x00, 0x00, 0x00, 0x01, 0x01, buff, 0x100);
		if ((calc_sum(buff)==id1 && dn==-1) || dn==0)
		{
			printf("Disk A F܂.\n");
			for (i=0; ma[i].sec; i++)
			{
				sprintf(fname,"MUS1%02d",i);
				fcut(fname, ma[i].trk, ma[i].trk>>1, ma[i].trk&1, ma[i].sec, 0x01, ma[i].ofs, ma[i].size);
			}
		}
		else if ((calc_sum(buff)==id2 && dn==-1) || dn==1)
		{
			printf("Disk B F܂.\n");
			fcut("DRIVER", 0x27, 0x13, 0x01, 0x01, 0x01, 0x0000, 0x0700);
			for (i=0; mb[i].sec; i++)
			{
				sprintf(fname,"MUS2%02d",i);
				fcut(fname, mb[i].trk, mb[i].trk>>1, mb[i].trk&1, mb[i].sec, 0x01, mb[i].ofs, mb[i].size);
			}
		}
		else if ((calc_sum(buff)==id3 && dn==-1) || dn==2)
		{
			printf("Disk C F܂.\n");
			for (i=0; mc[i].sec; i++)
			{
				sprintf(fname,"MUS3%02d",i);
				fcut(fname, mc[i].trk, mc[i].trk>>1, mc[i].trk&1, mc[i].sec, 0x01, mc[i].ofs, mc[i].size);
			}
		}
	}
	return 0;
}

